var Accordion = function(id, params) {
	this._id = id;
	this._params = params;
	this._obj = $("#" + id);
	this.init();
};

Accordion.prototype = {
	init : function() {
		var params = this._params;
		params.recentExpandedSection = 0;
		params.recentCollapsedSection = 0;
		var views = this._obj.children(".views").children();
		this._obj.empty();
		this._bg = $("<div class=\"bg\"></div>")
			.appendTo(this._obj);
		this._bd = $("<div class=\"bd\"></div>")
			.appendTo(this._obj);
		this._fg = $("<div class=\"fg\"></div>")
			.appendTo(this._obj);
		
		// generate headers and views
		var margin = params.margin;
		var titles = params.titles;
		var cIcons = params.cIcons;
		var eIcons = params.eIcons;
		var iconPlacement = params.iconp;
		var gap = params.gap;
		var eIndices = params.eIndices;
		for (var i = 0; i < titles.length; i ++) {
			var header = $("<div class=\"sectionHeader\"></div>").appendTo(this._fg);
			var iconLabel = createLabelObject(cIcons[i], iconPlacement, gap, "");
			if (iconPlacement == 0) {
				$("<div class=\"titleLabel\" style=\"position:relative;text-align:" + params.txt_a + ";padding-right:" + margin + "px;float:right;clear:none\">" + titles[i] + "</div>").appendTo(header);
				$("<div class=\"iconLabel\" style=\"position:relative;text-align:left;padding-left:" + margin + "px;float:left;clear:none\"></div>").append(iconLabel).appendTo(header);
			} else {
				$("<div class=\"iconLabel\" style=\"position:relative;text-align:right;padding-right:" + margin + "px;float:right;clear:none\"></div>").append(iconLabel).appendTo(header);
				$("<div class=\"titleLabel\" style=\"position:relative;text-align:" + params.txt_a + ";padding-left:" + margin + "px;float:left;clear:none\">" + titles[i] + "</div>").appendTo(header);
			}
			var section = $("<div class=\"sectionView\" style=\"position:relative;overflow:hidden;\"></div>").append(views.get(i)).appendTo(this._fg);
			section.css("display", $.inArray(i, eIndices) == -1 ? "none" : "block");
		}
		var me = this;
		this._fg.find(".icon").load(function() {
			updateElementAndReferences(me);
		});
		
		this.setupBehavior(this._obj);
		initReferences(this);
		setTimeout(function() {
			updateElementAndReferences(me);
			updateElementAndReferences(me);
		}, 0);
	},
	updateUI : function(obj) {
		var params = this._params;
		var _bg = obj.children(".bg");
		var _bd = obj.children(".bd");
		var _fg = obj.children(".fg");
		var width = obj.width();
		var height = obj.height();
		var borderWidth = params.bdw_0;
		var borderDelta = params.bdt_0 == "swing" ? 0 : borderWidth;
		var margin = params.margin;
		var hdrHeight = params.hdrHeight;
		var sectionCount = params.titles.length;
		
		// background filling
		_bd.height(height);
		generateBackgroundAndBorders(0, "", _bg, _bd, params);
		
		// section headers
		var fontName = params.f_n_0;
		var fontSize = params.f_s_0;
		var paddingTop = params.paddingTop;
		var paddingBottom = params.paddingBottom;
		var multiple = params.multiple;
		var minHeight = params.minHeight;
		var fixedHeight = height - hdrHeight * sectionCount - paddingTop - paddingBottom;
		var eIndices = params.eIndices;
		var cIcons = params.cIcons;
		var eIcons = params.eIcons;
		var titles = params.titles;
		_fg.children(".sectionHeader").width(width - borderDelta * 2).height(hdrHeight - borderDelta * 2).each(function(index) {
			var hdr = $(this);
			var bkBg = params.bg_0;
			var bkOpacity = params.bgo_0;
			params.bg_0 = params.hdrColor;
			params.bgo_0 = 255;
			generateBackgroundAndBorders(0, "", hdr, hdr, params);
			params.bg_0 = bkBg;
			params.bgo_0 = bkOpacity;
			
			var iconLabel = hdr.find(".iconLabel");
			var icon = iconLabel.find(".icon");
			var iconSrc = "images/dock/" + ($.inArray(index, eIndices) == -1 ? cIcons[index] : eIcons[index]);
			if (icon.attr("src") != iconSrc) {
				icon.attr("src", iconSrc);
			}
			var iconWrapper = iconLabel.find(".label");
			var iconWidth = iconWrapper.width();
			iconLabel.width(iconWidth).css("top", (hdrHeight - borderDelta * 2 - iconWrapper.height()) / 2);
			
			var titleLabel = hdr.find(".titleLabel").html(titles[index]);
			titleLabel.width(width - borderDelta * 2 - margin * 2 - iconWidth)
				.css("top", (hdrHeight - borderDelta * 2 - getTextSize(titleLabel.innerHTML, fontName, fontSize).height) / 2);
			applyFontParameters(0, "", titleLabel, params);
		}).children(".swingBd").css("left", "0px");
		
		// section views
		_fg.children(".sectionView").width(width - borderDelta * 2).each(function(index) {
			var isExpanded = ($.inArray(index, eIndices) != -1);
			var view = $(this);
			view.children().css("visibility", isExpanded ? "inherit" : "hidden");
			var contentHeight = view.children().height();
			contentHeight = contentHeight == 0 ? minHeight : contentHeight;
			var sectionHeight = paddingTop + paddingBottom + (multiple ? contentHeight : fixedHeight) - borderDelta;
			view.height(sectionHeight).css({
				"display" : isExpanded ? "block" : "none",
				"border-style" : "solid",
				"border-width" : "0px",
				"border-bottom-width" : borderDelta + "px",
				"border-color" : params.bdc_0
			});
		});
		
		// shadow
		applyShadow(obj, _bd, params.shadow);
	},
	setupBehavior : function(obj) {
		var me = this;
		var params = this._params;
		var multiple = params.multiple;
		var eIndices = params.eIndices;
		var _fg = obj.children(".fg");
		var headers = _fg.children(".sectionHeader");
		headers.css("cursor", "pointer").click(function() {
			var index = headers.index(this);
			var pos = $.inArray(index, eIndices);
			if (multiple) {
				if (pos == -1) {
					eIndices.push(index);
					eIndices.sort();
					params.recentExpandedSection = index + 1;
					params.recentCollapsedSection = 0;
				} else {
					eIndices.splice(pos, 1);
					params.recentExpandedSection = 0;
					params.recentCollapsedSection = index + 1;
				}
				updateElementAndReferences(me);
				$("#" + me._id + ",[ref='" + me._id + "']").each(function() {
					me._updateSize($(this));
				});
				updateElementAndReferences(me);
				$("#" + me._id).trigger("SectionStateChanged");
			} else {
				if (pos == -1) {
					eIndices.splice(0);
					eIndices.push(index);
					updateElementAndReferences(me);
					params.recentCollapsedSection = params.recentExpandedSection == 0 ? 1 : params.recentExpandedSection;
					params.recentExpandedSection = index + 1;
					$("#" + me._id).trigger("SectionStateChanged");
				}
			}
		});
	},
	_updateSize : function(obj) {
		var height = obj.height();
		var params = this._params;
		var _fg = obj.children(".fg");
		var headers = _fg.children(".sectionHeader");
		var views = _fg.children(".sectionView");
		var h = 0;
		views.add(headers).each(function() {
			var block = $(this);
			if (block.css("display") != "none") {
				var bdTop = parseInt(block.css("border-top-width"));
				var bdBottom = parseInt(block.css("border-bottom-width"));
				h += block.height() + bdTop + bdBottom;
			}
		});
		if (h != height) {
			obj.height(h);
		}
	},
	getSectionCount : function() {
		return this._params.titles.length;
	},
	getSectionTitles : function() {
		var titles = [undefined];
		return titles.concat(this._params.titles);
	},
	getSectionExpandedFlags : function() {
		var params = this._params;
		var count = params.titles.length;
		var eIndices = this._params.eIndices;
		var flags = [];
		for (var i = 0; i < count; i ++) {
			flags[i + 1] = $.inArray(i, eIndices) == -1 ? 0 : 1;
		}
		return flags;
	},
	getFirstExpandedSection : function() {
		var eIndices = this._params.eIndices;
		if (eIndices.length > 0) {
			return eIndices[0] + 1;
		}
		return 0;
	},
	getRecentExpandedSection : function() {
		return this._params.recentExpandedSection;
	},
	getRecentCollapsedSection : function() {
		return this._params.recentCollapsedSection;
	},
	setSectionTitle : function(targets, index, value) {
		for (var i = 0; i < targets.length; i ++) {
			var elem = getForeUIElementById(targets[i]);
			if (elem) {
				var params = elem._params;
				var count = params.titles.length;
				if (index > 0 && index <= count) {
					params.titles[index - 1] = value;
					updateElementAndReferences(elem);
				}
			}
		}
	},
	expandSection : function(targets, index) {
		var index = parseInt(index);
		for (var i = 0; i < targets.length; i ++) {
			var elem = getForeUIElementById(targets[i]);
			if (elem) {
				var params = elem._params;
				var multiple = params.multiple;
				var eIndices = params.eIndices;
				var count = params.titles.length;
				if (index > 0 && index <= count && $.inArray(index - 1, eIndices) == -1) {
					if (!multiple) {
						params.recentCollapsedSection = eIndices.length > 0 ? eIndices[0] + 1 : 0;
						eIndices.splice(0);
					} else {
						params.recentCollapsedSection = 0;
					}
					params.recentExpandedSection = index;
					eIndices.push(index - 1);
					eIndices.sort();
					updateElementAndReferences(elem);
					$("#" + elem._id + ",[ref=" + elem._id + "]").each(function() {
						elem._updateSize($(this));
					});
					updateElementAndReferences(elem);
					$("#" + elem._id).trigger("SectionStateChanged");
				}
			}
		}
	},
	collapseSection : function(targets, index) {
		var index = parseInt(index);
		for (var i = 0; i < targets.length; i ++) {
			var elem = getForeUIElementById(targets[i]);
			if (elem) {
				var params = elem._params;
				var multiple = params.multiple;
				var eIndices = params.eIndices;
				var count = params.titles.length;
				if (multiple && index > 0 && index <= count) {
					var pos = $.inArray(index - 1, eIndices);
					if (pos != -1) {
						eIndices.splice(pos, 1);
						params.recentExpandedSection = 0;
						params.recentCollapsedSection = index;
						updateElementAndReferences(elem);
						$("#" + elem._id + ",[ref=" + elem._id + "]").each(function() {
							elem._updateSize($(this));
						});
						updateElementAndReferences(elem);
						$("#" + elem._id).trigger("SectionStateChanged");
					}
				}
			}
		}
	}
};