var Bezier = function(id, params) {
	this._id = id;
	this._params = params;
	this._obj = $("#" + id);
	this.init();
};

Bezier.prototype = {
	init : function() {
		initReferences(this);
		var me = this;
		setTimeout(function() {
			updateElementAndReferences(me);
		}, 0);
	},
	updateUI : function(obj) {
		var params = this._params;
		var width = obj.width();
		var height = obj.height();
		var type = params.type;
		
		// create canvas
		canvas = createCanvas(width, height, params);
		obj.empty().append(canvas);
		$(canvas).css("position", "absolute");
		
		var ctx = getCanvasContext(canvas, params);
		setLineStyle(ctx, params.bdc_0, params.bdw_0, params.bdt_0);
		ctx.beginPath();
		ctx.moveTo(params.points[0].x, params.points[0].y);
		ctx.bezierCurveTo(params.points[1].x, params.points[1].y, params.points[2].x, params.points[2].y, params.points[3].x, params.points[3].y);
		ctx.stroke();
	}
};