var CheckBox = function(id, params) {
	this._id = id;
	this._params = params;
	this._obj = $("#" + id);
	this.init();
};

CheckBox.prototype = {
	init: function() {
		var params = this._params;
		this._obj.empty();
		this._bg = $("<div class=\"bg\"></div>")
			.appendTo(this._obj);
		this._bd = $("<div class=\"bd\"></div>")
			.appendTo(this._obj);
		var label = createLabelObject(params["icon_" + params.state], params.icon_p, params["gap_" + params.state], params.text, true);
		this._fg = $("<div class=\"fg vcenter_outter\"><div class=\"vcenter_middle\"><div class=\"vcenter_inner\">" + label.html() + "</div></div></div>")
			.appendTo(this._obj);
			
		this.setupBehavior(this._obj);
		initReferences(this);

		var me = this;
		setTimeout(function() {
			setState(me, me._params.state, true);
		}, 0);
	},
	updateUI: function(obj) {
		var params = this._params;
		var state = params.state;
		var _bg = obj.children(".bg");
		var _bd = obj.children(".bd");
		var _fg = obj.children(".fg");
		var width = obj.width();
		var height = obj.height();
		
		// background filling
		_bd.css("border-width", "0px").width(width).height(height);
		generateBackgroundAndBorders(state, "", _bg, _bd, params);
		
		// icon
		_fg.find(".icon").attr("src", "images/" + params["icon_" + params.state]);
		
		// text
		_fg.width(width).height(height).css({
			"cursor": (state == 64 || state == 96) ? "default" : "pointer"
		});
		applyFontParameters(state, "", _fg.find(".vcenter_middle"), params);
		// shadow
		applyTextShadow(_fg, params);
	},
	setupBehavior : function(obj) {
		var params = this._params;
		var me = this;
		obj.mouseenter(function() {
			setState(me, (params.state & 32) ? 48 : 16);
		}).mouseleave(function() {
			setState(me, (params.state & 32) ? 32 : 0);
		}).mousedown(function() {
			var curTime = Date.now();
			if (!obj._lastToggleTime || curTime - obj._lastToggleTime > 500) {
				setState(me, (params.state & 32) ? 16 : 48);
				obj._lastToggleTime = curTime;
			}
		});
	},
	getSelected : function() {
		return (this._params.state & 32) > 0;
	},
	selectCheckBox : function(targets, selected, includeSiblings) {
		var checkboxes = includeSiblings ? findSiblingsInGroup(targets, true) : targets;
		for (var i = 0; i < checkboxes.length; i ++) {
			var elem = getForeUIElementById(checkboxes[i]);
			if (elem) {
				var newSelected = (elem._params.state & 32) ? false : true;
				if (selected == 0) {
					newSelected = false;
				} else if (selected == 1) {
					newSelected = true;
				}
				if (!newSelected) {
					setState(elem, elem._params.state & 223);
				} else {
					setState(elem, elem._params.state | 32);
				}
			}
		}
	},
	onSelected : function() {
		$("#" + this._id).trigger("Selected");
	},
	onUnselected : function() {
		$("#" + this._id).trigger("Unselected");
	}
};