var PostIt = function(id, params) {
	this._id = id;
	this._params = params;
	this._obj = $("#" + id);
	this.init();
};

PostIt.prototype = {
	init : function() {
		var me = this;
		var params = this._params;
		this._text = this._obj.html();
		this._obj.empty();
		this._bg = $("<div class=\"bg\"></div>").appendTo(this._obj);
		
		this._bd = $("<div class=\"bd\"></div>").appendTo(this._obj);
		var pinIcon = $("<img class=\"pinIcon\" />").attr("src", "images/PostIt_PinIcon__Normal.png").css({
			"position" : "absolute",
			"left" : "5px",
			"top" : ((params.headLength - 10) / 2) + "px"
		}).appendTo(this._bd);
		var footerIcon = $("<img class=\"footerIcon\" />").attr("src", "images/PostIt_FooterIcon__Normal.png").css({
			"position" : "absolute"
		}).appendTo(this._bd);
		var ftIcon = new Image();
		ftIcon.onload = function() {
			footerIcon.width(this.width).height(this.height);
			updateElementAndReferences(me);
		};
		ftIcon.src = "images/PostIt_FooterIcon__Normal.png";
		
		this._fg = $("<div class=\"fg\">" + htmlToView(this._text) + "</div>").css({
			"padding-left" : params.margin.left + "px",
			"padding-right" : params.margin.right + "px",
			"padding-top" : (params.headLength + params.margin.top) + "px",
			"text-align" : params.txt_a_0
		}).appendTo(this._obj);
		applyFontParameters(0, "", this._fg, params);
		
		initReferences(this);
		setTimeout(function() {
			updateElementAndReferences(me);
		}, 0);
	},
	updateUI : function(obj) {
		var params = this._params;
		var _bg = obj.children(".bg");
		var _bd = obj.children(".bd");
		var _fg = obj.children(".fg");
		var width = obj.width();
		var height = obj.height();
		
		// background filling
		_bd.css("border-width", "0px").width(width).height(height);
		generateBackgroundAndBorders(0, "", _bg, _bd, params);
		
		// footer icon
		_bd.find(".footerIcon").position({
			"my" : "right bottom",
			"at" : "right bottom",
			"of" : obj
		});
		
		// text
		_fg.width(width - params.margin.left - params.margin.right);
		
		// shadow
		applyShadow(this._obj, _bd, params.shadow);
	}
};