var RadioButtonGroup = function(id, params) {
	this._id = id;
	this._params = params;
	this._obj = $("#" + id);
	this.init();
};

RadioButtonGroup.prototype = {
	init : function() {
		var me = this;
		setTimeout(function() {
			me.setupBehavior(me._obj);
			initReferences(me);
			updateElementAndReferences(me);
		}, 0);
	},
	updateUI : function(obj) {
		// shadow
		var params = this._params;
		obj.children(".elem").each(function(index) {
			applyTextShadow($(this).children(".fg"), params);
		});
	},
	setupBehavior : function(obj) {
		var me = this;
		obj.children(".elem").each(function(index){
			$(this).mousedown(function() {
				me.setSelectedIndex(index + 1);
			});
		});
	},
	getSelectedIndex : function() {
		return this._params.selr + 1;
	},
	setSelectedIndex : function(index) {
		var params = this._params;
		var count = params.count;
		var buttonIds = params.buttonIds;
		if (index >= 0 && index <= count && params.selr != index - 1) {
			for (var i = 0; i < buttonIds.length; i ++) {
				var elem = getForeUIElementById(buttonIds[i]);
				if (elem) {
					if (i == index - 1) {
						elem._params.state |= 32;
					} else {
						elem._params.state &= (~32);
					}
					updateElementAndReferences(elem);
				}
			}
			params.selr = index - 1;
			$("#" + this._id).trigger("Selection_Changed");
		}
	},
	getSelectedText : function() {
		var params = this._params;
		var count = params.count;
		var buttonIds = params.buttonIds;
		var selIndex = this.getSelectedIndex() - 1;
		if (selIndex >= 0 && selIndex < count) {
			var selElem = getForeUIElementById(buttonIds[this.getSelectedIndex() - 1]);
			if (selElem) {
				return selElem._params.text;
			}
		}
		return "";
	},
	onStateChanged : function() {
		var params = this._params;
		var count = params.count;
		var buttonIds = params.buttonIds;
		for (var i = 0; i < count; i ++) {
			var button = getForeUIElementById(buttonIds[i]);
			if (button) {
				var isSelected = (button._params.state & 32) > 0;
				button._params.state = params.state | (isSelected ? 32 : 0);
				updateElementAndReferences(button);
			}
		}
	}
};