var Reference = function(id, params) {
	this._id = id;
	this._params = params;
	this._obj = $("#" + id);
	this._ref = this._obj.attr("ref");
	if (params.tooltip) {
		this._obj.attr("title", params.tooltip);
	}
};

Reference.prototype = {
	init: function() {
	},
	updateUI: function(obj) {
		updateElementAndReferences(window.foreui.elements[this._ref]);
	},
	setupBehavior : function(obj) {
	},
	setReferenceTarget : function(tar) {
		if (tar && tar.indexOf("Reference_") == 0) return;
		var oldTar = this._obj.attr('ref');
		if (oldTar == tar) return;
		var ref = this._id;
		
		// delete behavior from old reference target
		var oldBehavior = window.foreui.behaviors[oldTar];
		if (oldBehavior != undefined) {
			for (var i = 0; i < oldBehavior.length; i ++) {
				oldBehavior[i].instance.selector.unbind();
			}
		}
		
		// enable FOCUSED_ELEMENT_ID
		var oldTarElem = window.foreui.elements[oldTar];
		initDefaultBehaviorForElement(oldTarElem);
		
		// restore the default behavior on old target
		if(oldTarElem && oldTarElem.setupBehavior) {
			oldTarElem.setupBehavior(oldTarElem._obj)
		}
		
		var refBehavior = window.foreui.behaviors[ref];
		if (refBehavior != undefined) {
			for (var i = 0; i < refBehavior.length; i ++) {
				refBehavior[i].instance.selector.unbind();
				refBehavior[i].instance.callMe();
			}
		}
		
		// enable FOCUSED_ELEMENT_ID
		var refElem = window.foreui.elements[ref];
		initDefaultBehaviorForElement(refElem);
		
		// restore the default behavior on reference element
		if(refElem && refElem.setupBehavior) {
			refElem.setupBehavior(refElem._obj)
		}
		
		if (tar && tar != "") {
			// set new reference target
			this._obj.attr('ref',tar);
			initReferences(window.foreui.elements[tar]);
			updateElementAndReferences(window.foreui.elements[tar]);
	
			// set behavior (click events, etc) for new reference targets
			var tarBehavior = window.foreui.behaviors[tar];
			if (tarBehavior != undefined) {
				for (var i = 0; i < tarBehavior.length; i ++) {
					tarBehavior[i].instance.selector.unbind();
					tarBehavior[i].instance.selector = $("#"+ tar +",[ref=\'" + tar +"\']");
					tarBehavior[i].instance.callMe();
					tarBehavior[i].instance.selector.filter("[id^='Reference_']").each(function() {
						var refId = $(this).attr("id");
						initDefaultBehaviorForElement(window.foreui.elements[refId]);
						if (refId != ref) {
						var refRefBehavior = window.foreui.behaviors[refId];
							if (refRefBehavior != undefined) {
								for (var j = 0; j < refRefBehavior.length; j ++) {
									refRefBehavior[i].instance.selector = $("#"+refId);
									refRefBehavior[i].instance.callMe();
								}
							}
						}
					});
				}
			}
	
			// enable FOCUSED_ELEMENT_ID
			var newTarElem = window.foreui.elements[tar];
			initDefaultBehaviorForElement(newTarElem);
			
			// restore the default behavior for new target
			if(newTarElem.setupBehavior) {
				newTarElem.setupBehavior(newTarElem._obj)
			}
		} else {
			this._obj.removeAttr('ref').empty();
		}
			
		// restore the behavior for old reference target
		if (oldBehavior != undefined) {
			for (var i = 0; i < oldBehavior.length; i ++) {
				oldBehavior[i].instance.selector = $("#"+oldTar+",[ref='"+oldTar+"']");
				oldBehavior[i].instance.callMe();
				oldBehavior[i].instance.selector.filter("[id^='Reference_']").each(function() {
					var refId = $(this).attr("id");
					initDefaultBehaviorForElement(window.foreui.elements[refId]);
					var oldRefTarBehavior = window.foreui.behaviors[refId];
					if (oldRefTarBehavior != undefined) {
						for (var j = 0; j < oldRefTarBehavior.length; j ++) {
							oldRefTarBehavior[i].instance.selector = $("#"+refId);
							oldRefTarBehavior[i].instance.callMe();
						}
					}
				});
			}
		}
	}
};
