var ScrollableContainer = function(id, params) {
	this._id = id;
	this._params = params;
	this._obj = $("#" + id);
	this.init();
};

ScrollableContainer.prototype = {
	init : function() {
		var params = this._params;
		var content = this._obj.children();
		this._obj.empty();
		this._bg = $("<div class=\"bg\"></div>")
			.appendTo(this._obj);
		this._bd = $("<div class=\"bd\"></div>")
			.appendTo(this._obj);
		this._fg = $("<div class=\"fg scrollable\"></div>").append(content).css({
			"overflow-x" : params.hsc ? "scroll" : "hidden",
			"overflow-y" : params.vsc ? "scroll" : "hidden" 
		}).appendTo(this._obj);
			
		initReferences(this);
		var me = this;
		setTimeout(function() {
			updateElementAndReferences(me);
		}, 0);
	},
	updateUI : function(obj) {
		var params = this._params;
		var _bg = obj.children(".bg");
		var _bd = obj.children(".bd");
		var _fg = obj.children(".fg");
		var width = obj.width();
		var height = obj.height();
		
		// background filling
		_bd.css("border-width", "0px").width(width).height(height);
		generateBackgroundAndBorders(0, "", _bg, _bd, params);
		
		// foreground
		var borderWidth = params.bdw_0;
		_fg.css({
			"left" : borderWidth + "px",
			"top" : borderWidth + "px",
			"width" : (width - borderWidth * 2) + "px",
			"height" : (height - borderWidth * 2) + "px"
		});
		
		// shadow
		applyShadow(obj, _bd, params.shadow);
	}
};