var TextEditBox = function(id, params) {
	this._id = id;
	this._params = params;
	this._obj = $("#" + id);
	this.init();
};

TextEditBox.prototype = {
	init : function() {
		var params = this._params;
		this._text = this._obj.html().replace(/\t/g, '');
		this._obj.empty();
		this._bg = $("<div class=\"bg\"></div>")
			.appendTo(this._obj);
		this._bd = $("<div class=\"bd\"></div>")
			.appendTo(this._obj);
		this._fg = $("<div class=\"fg\"></div>")
			.appendTo(this._obj);
		
		var align = params["txt_a_" + params.state];
		var margin = params.margin;
		$(params.multirow ? "<textarea class=\"edit\">" + this._text + "</textarea>" 
			: "<input class=\"edit\" type=\"" + (params.encrypt ? "password" : "text") + "\" value=\"" + this._text + "\" />")
			.css({
				width : "100%",
				height : "100%",
				"text-align" : align,
				"padding-left" : margin,
				"padding-right" : margin,
				"background-color" : "transparent",
				"border-width" : "0px",
				"overflow" : "hidden"
			})
			.appendTo(this._fg);

		this.setupBehavior(this._obj);
		initReferences(this);

		var me = this;
		setTimeout(function() {
			setState(me, me._params.state, true);
		}, 0);
	},
	updateUI : function(obj) {
		var params = this._params;
		var state = params.state;
		var _bg = obj.children(".bg");
		var _bd = obj.children(".bd");
		var _fg = obj.children(".fg");
		var width = obj.width();
		var height = obj.height();
		
		// background filling
		_bd.css("border-width", "0px").width(width).height(height);
		generateBackgroundAndBorders(state, "", _bg, _bd, params);
		
		// text
		var margin = params.margin;
		_fg.find(".edit").width(width - margin * 2).height(height).val(this._text).prop("disabled", (state & 64) > 0);
		applyFontParameters(state, "", _fg.find(".edit"), params);
		
		// shadow
		applyShadow(obj, _bd, params.shadow);
	},
	setupBehavior : function(obj) {
		var me = this;
		obj.children(".fg").find(".edit").change(function() {
			me._text = $(this).val();
			$("#" + me._id).trigger("Value_Changed");
			updateElementAndReferences(me);
		}).focus(function() {
			window.foreui.focusedElementId = me._id;
			onPropertyValueChanged("FOCUSED_ELEMENT_ID", me._id);
		});
	},
	getValue : function() {
		return this._obj.children(".fg").find(".edit").val();
	},
	getCurrentValue : this.getValue,
	setCurrentValue : function(value) {
		var oldVal = this.getValue();
		if (oldVal != value) {
			this._text = value;
			this._obj.children(".fg").find(".edit").val(value);
			$("#" + this._id).trigger("Value_Changed");
			updateElementAndReferences(this);
		}
	},
	setFocus : function() {
		var edit = this._obj.children(".fg").find(".edit").get(0);
		edit.focus();
		edit.select();
		window.foreui.focusedElementId = this._id;
		onPropertyValueChanged("FOCUSED_ELEMENT_ID", this._id);
	},
	getTextLength : function() {
		return this.getValue().length;
	}
};